<template>
    <div
        v-if="popup"
        class="page-container"
    >
        <div class="edit__top">
            <div class="edit__actions">
                <ToggleButton
                    v-model="popup.status"
                    :font-size="12"
                    class="toggle-btn"
                    :height="24"
                    :labels="true"
                    color="rgb(45, 119, 245)"
                />
                <div>
                    <b-btn
                        class="btn blue-btn"
                        variant="primary"
                        @click="updatePopup"
                    >
                        Save
                    </b-btn>
                </div>
            </div>
            <Tabs
                :items="tabs"
                @switch="tabIndex = $event"
            />
        </div>
        <ValidationObserver
            ref="obs"
        >
            <div class="row">
                <template v-for="item in tabs">
                    <component
                        :is="item.component"
                        v-show="item.component.toLowerCase() == activeTab.toLowerCase()"
                        :key="item.component"
                        :show-thank="showThank"
                        :preview-type="previewType"
                        :show-new-modal="showNewModal"
                        :popup="popup"
                        class="col-xl-4"
                    />
                </template>
                <Preview
                    class="col-xl-8 edit__preview"
                    :preview-type="previewType"
                    :show-new-modal="showNewModal"
                    :show-thank="showThank"
                    :active-offers="activeOffers"
                    :popup="popup" 
                />
                <!-- <New /> -->
            </div>
        </ValidationObserver>
    </div>
</template>

<script>
import PopupSettings from "@/components/growth-tools/PopupSettings";
import TimerSettings from "@/components/growth-tools/TimerSettings";
import Offers from "@/components/growth-tools/Offers";
import headers from '@/helpers/authHeader';
import link from '@/helpers/backLink';
import Bar from "@/components/growth-tools/Bar";
import DisplaySettings from "@/components/growth-tools/DisplaySettings";
import Preview from "@/components/growth-tools/Preview";
import Tabs from "@/components/elements/Tabs"
// import New from '@/components/growth-tools/New'

export default {
    name: "Edit",
    components: {Preview, DisplaySettings, Bar, Offers, TimerSettings, PopupSettings, Tabs},
    mixins: [headers, link],
    data() {
        return {
            previewType: {type: 0},
            popup: null,
            loading: true,
            tabIndex: 0,
            activeOffers: 0,
            position: [],
            showThank: [
                {active: false},
                {active: false},
                {active: false}
            ],
            tabs: [
                {icon: '/images/growth-tool/popup-settings.svg', title: 'Pop Up Settings', component: 'PopupSettings'},
                {icon: '/images/growth-tool/timer-settings.svg', title: 'Timer Settings', component: 'TimerSettings'},
                {icon: '/images/growth-tool/offers.svg', title: 'Offers', component: 'Offers'},
                {icon: '/images/growth-tool/bar-settings.svg', title: 'Bar Settings', component: 'Bar'},
                {icon: '/images/growth-tool/display-settings.svg', title: 'Display Settings', component: 'DisplaySettings'},
            ]
        }
    },
    computed: {
        activeTab() {
            return this.tabs[this.tabIndex].component
        },
        showNewModal() {
            return this.$store.state.shop.abTesting.array.includes('Growth_B')
        },
    },
    created() {
        axios.get(`${this.getSegment()}/growth/${this.$route.params.id}`, this.getUserHeader())
            .then(response => {
                this.popup = response.data
                this.loading = false;
            });
    },
    methods: {
        changeStatus() {
            axios.put(`${this.getSegment()}/growth/${this.$route.params.id}/status`, {status: this.popup.status}, this.getUserHeader())
                .then(response => {

                });
        },
        async updatePopup() {
            const result = await this.$refs.obs.validate();
            const valid = await this.$refs.obs
            if(result) {
                this.loading = true
                const data = JSON.parse(JSON.stringify(this.popup))

                const deleteKeys = ['popup_image', 'background_image', 'popup_image_closed']
                deleteKeys.forEach(key => {
                    if(data[key]) delete data[key]
                })
                axios.put(`${this.getSegment()}/growth/${this.$route.params.id}`, {data}, this.getUserHeader())
                    .then(response => {
                        this.loading = false
                        this.$notify({
                            type: 'success',
                            title: 'Changes saved'
                        });
                    });
                setTimeout(() => {
                    this.$refs.obs.reset()
                }, 2000)
                
                
            } else this.getFormErrors(valid.errors)
        }
    }
}
</script>

<style lang="scss">
.white-space {
    background-color: white;
    border: none !important;
    border-radius: 5px;
}

.page-container {
    margin-top: 45px;
    min-height: 100vh;
}

.action-container {
    margin-bottom: -40px;
}

.title-container {
    display: flex;
    justify-content: center;
    align-items: center;
}

.title-icon {
    margin-right: 15px;
}


.close-button {
    font-size: 22px;
    font-weight: 500;
    position: absolute;
    right: 20px;
    top: 10px;
}

.stand-container {
    display: flex;
    justify-content: center;

    img {
        margin-top: -10px;
    }
}

.hide-stand {
    display: none;
}

.pop-up-main-container {
    position: absolute;
    top: 40px;
    padding: 0px 15px;
    display: flex;
    flex-direction: column;
    justify-content: center;
    bottom: 40px;
    right: 45px;
    left: 45px;
}


.desktop-circle-camera {
    width: 10px;
    height: 10px;
    top: 11px;
    border-radius: 50%;
    position: absolute;
    background: rgba(0, 0, 0, 0.1);
    right: calc(50% - 5px);
}

.preview-store-background {
    position: absolute;
    background-color: rgba(0, 0, 0, .2);
    top: 5%;
    right: 3.5%;
    bottom: 5%;
    left: 3.5%;
    border-radius: 5px;
}


.growth-tab-container {
    display: flex;
    align-items: center;
}

.preview {
    text-align: center;
}

.popup-preview-toggle-container {
    display: flex;
    align-items: center;
    margin-bottom: 10px;
}

.pretty {
    margin-right: 0px !important;
}

.phone-input-container {
    margin-left: 5px;
}

.preview-thank-code {
    font-size: 16px;
    font-weight: bold;
}

.timer-style-2 {
    height: 80px !important;
    font-weight: 400;
}

.timer-style-1 {
    height: 80px !important;
}

.growth-action-icons {
    width: 15px;
    height: 15px;
}

.mobile-border-preview {
    max-width: 350px;
    padding: 0 !important;
    margin-right: auto;
    margin-left: auto;

    .close-button {
        top: 16px !important;
    }

    .growth-cart-container {
        height: auto !important;
    }

    .timer-style-2 {
        height: 52px !important;
    }

    .timer-style-1 {
        height: 52px !important;
        margin-top: 15px !important;
    }

    background: none !important;


    .second-style {
        .growth-cart-container {
            width: 80% !important;
        }
    }

    .email-input {
        width: 80% !important;
    }

    .timer-number-background span {
        font-size: 16px !important;
    }

    .timer-number-background {
        min-width: 160px !important;
        padding: 2px 15px !important;
    }

    .gift-size-1 {
        height: 25px;
    }

    .gift-size-2 {
        height: 35px;
    }

    .gift-size-3 {
        height: 45px;
    }

    .timer-style-1 {
        flex-direction: column;
    }

    .growth-cart-container {
        box-shadow: none;
    }

    .pop-up-main-container {
        right: 15px;
        left: 15px;
        padding-top: 10px;
    }

    .preview-box .row {
        margin-left: -15px !important;
        margin-right: -15px !important;
    }

    .growth-cart-container {
        width: 94% !important;
    }

    .timer-number-style-1 {
        padding: 5px 5px !important;
        font-size: 16px !important;
    }

    .timer-style-2 {
        margin-top: 15px !important;
    }

    .timer-text {
        margin-right: 0;
        margin-bottom: 5px;
    }

    .growth-cart-container {
        width: 94%;
    }

    .nav-btn-prev {
        width: 30px !important;
        height: 30px !important;
        left: 0 !important;
    }

    .nav-btn-next {
        width: 30px !important;
        height: 30px !important;
        right: 0 !important;
    }

    .bar-block {
        font-size: 10px;
    }

    .desktop-circle-camera {
        width: 60px;
        height: 10px;
        top: 11px;
        border-radius: 5px;
        position: absolute;
        background: rgba(0, 0, 0, 0.1);
        right: calc(50% - 30px);
    }

    .preview-box {
        position: relative;
        width: 100%;
        height: 600px;
        padding-top: 60px !important;
        padding-bottom: 60px !important;
    }

    .preview-store-background {
        position: absolute;
        background-color: rgba(0, 0, 0, 0.2);
        top: 6%;
        right: 6.5%;
        bottom: 5%;
        left: 6.5%;
    }

    .gift-container {
        margin-bottom: 20px;
    }

    .items-center {
        flex-direction: column;
    }

}

.messenger-container {
    display: flex;
    font-size: 8px;
    align-items: center;

    img {
        margin-right: 2px;
    }
}


.get-discount-btn-full {
    color: #98A0A6;
    padding: 4px;
    background: #DEE1E6;
    border-radius: 5px;
    text-align: center;
    font-size: 11px;
    margin-top: 10px;
    width: 100%;
    min-width: 95px;
}

.growth-input-icon-container {
    min-width: 25px;
    min-height: 25px;
    width: 25px;
    height: 25px;
    display: flex;
    margin-right: 10px;
    border-radius: 5px;
    justify-content: center;
    align-items: center;
}

.messenger-container2 {
    display: flex;
    font-size: 8px;
    align-items: center;
    color: #98A0A6;
    font-weight: 300;
    margin-top: 5px;

    img {
        margin-right: 2px;
    }

    a {
        font-weight: 500;
        margin-left: 2px;
        color: #98A0A6;
    }
}

.phone-number {
    font-size: 8px;
    text-align: left;
    margin-bottom: -5px;
}

.sms-phone-container {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    border-radius: 5px;
}

.facebook-check {
    font-size: 8px;
    width: 42px;
    display: flex;
}

.input-img-container {
    position: relative;
}

.growth-cart-container {
    background: white;
    display: flex;
    flex-direction: column;
    border-radius: 10px;
    height: 100%;
    margin-top: 8px;
    justify-content: center;
    align-items: center;
    box-shadow: 0 0 4px 0 rgba(0, 0, 0, 0.2), 0 4px 3px rgba(0, 0, 0, 0.08);
    @media screen and (max-width: 1500px) {
        width: 65% !important;
    }
    @media screen and (max-width: 660px) {
        width: 90% !important;
    }

}

@media screen and (max-width: 660px) {
    .nav-btn-prev {
        left: 15% !important;
    }
    .nav-btn-next {
        right: 15% !important;
    }
}


.gift-container {
    align-items: end;
    @media screen and (max-width: 1200px) {
        height: auto;
        margin-top: 20px;
    }
}

.action-gift-container {
    justify-content: flex-end;
    display: flex;
    flex-direction: column;
    padding: 20px 20px;
    border-radius: 5px;
    box-shadow: 0px 0px 4px rgba(0, 0, 0, 0.12);
    @media screen and (max-width: 1200px) {
        justify-content: center;
        height: auto;
    }
}

.usa-icon {
    position: absolute;
    top: 9px;
    left: 2px;
}

.arrow-down {
    position: absolute;
    top: 12px;
    left: 12px;
}

.gift-input-container {
    position: relative;
    padding-right: 17px;
    min-width: 100px;
    margin-top: 7px;
    @media screen and (max-width: 1200px) {
        min-width: 120px;
    }
}

.email-input {
    width: calc(100% - 35px) !important;
    height: 25px;
    padding-left: 5px;
    border: 1px solid #DAE7FF;
    border-radius: 5px;
    font-size: 12px;
    @media screen and (max-width: 1200px) {
        font-size: 9px;
    }
}

.sms-phone-input {
    width: 100%;
    height: 14px;
    border: 1px solid #DAE7FF;
    border-radius: 5px;
    font-size: 7px;
    padding-left: 17px;
}

.get-discount-btn {
    color: #98A0A6;
    position: absolute;
    right: 0;
    bottom: 0;
    padding: 3px;
    background: #DEE1E6;
    border-radius: 5px;
    text-align: center;
    font-size: 7px;
}


.timer-number-style-1 {
    padding: 5px 7px;
    font-size: 20px;
    background-color: #F5F6FA;
    border-radius: 5px;
    margin-right: 5px;
}

.space-margin {
    margin-left: 15px;
    cursor: pointer;
}

.timer-text {
    margin-right: 10px;
    @media screen and (max-width: 500px) {
        margin-bottom: 10px;
        margin-right: 0px;
    }
}

.timer-style-1 {
    display: flex;
    justify-content: center;
    color: #707070;
    align-items: center;
    height: 80px;
    margin-top: 10px;
    font-weight: 400;
    @media screen and (max-width: 500px) {
        flex-direction: column;
        font-size: 10px;
    }
}

.border-preview {
    position: relative;
    padding: 70px;
    @media screen and (max-width: 500px) {
        padding: 40px;
    }
}

.bar-block {
    background-color: #E5E6E8;
    position: absolute;
    display: flex;
    justify-content: space-between;
    align-items: center;
    bottom: 0;
    font-size: 10px;
    width: 100%;
    left: 0;
    height: 35px;
    padding-left: 15px;

    @media screen and (max-width: 600px) {
        font-size: 10px;
    }
    @media screen and (max-width: 400px) {
        font-size: 8px;
    }
}

.edit__set_block {
    position: relative;
}

.top {
    top: 0;
    border-top-right-radius: 5px;
    border-top-left-radius: 5px;

}

.bot {
    bottom: 0;
    border-bottom-right-radius: 5px;
    border-bottom-left-radius: 5px;
}

.right-icon {
    margin-right: 15px;
    float: right;
}

.gift-size-1 {
    height: 45px;
}

.gift-size-2 {
    height: 55px;
}

.gift-size-3 {
    height: 75px;
}

.gift-size-4 {
    height: 95px;
    margin: 10px;
}

.gifts-parent {
    display: flex;
    justify-content: center;
}

.push-text {
    @media screen and (max-width: 1200px) {
        font-size: 9px !important;
        padding-left: 0 !important;
    }
}

.preview-box {
    height: 600px;
    // box-shadow: 0px 0px 24px 6px rgba(34, 60, 80, 0.2);
    padding: 0 !important;
    background-color: white !important;
    display: flex;
    border-radius: 40px;
    flex-direction: column;
    justify-content: center;

    .row {
        margin-left: 0 !important;
        margin-right: 0 !important;
        margin-top: 20px;
    }

    @media screen and (max-width: 1200px) {
        padding-top: 60px !important;
        padding-bottom: 60px !important;
        width: auto;
        position: relative;
    }
}

h4 {
    font-size: 18px;
}
</style>
<style scoped lang="scss">
.edit__top {
    flex-direction: row-reverse;
}
@media(max-width: 370px) {
    ::v-deep {
        .nav.nav-pills {
            flex-direction: column;
        }
    }
}

</style>
